'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var Repetition = (function (_Atom) {
  function Repetition(atom, min, max) {
    var tag = arguments[3] === undefined ? 'repetition' : arguments[3];

    _classCallCheck(this, Repetition);

    _Atom.call(this);

    if (max < min) {
      throw new Error();
    }

    this._atom = atom;
    this._min = min;
    this._max = max;
    this._tag = tag;
  }

  _inherits(Repetition, _Atom);

  Repetition.prototype.run = function run(stream, index) {
    var values = [this._tag];
    var result = undefined;

    for (var iteration = 0; iteration < this._max; iteration++) {
      result = this._atom.run(stream, index).aggregate(result);

      if (result.status) {
        values.push(result.value);
        index = result.index;
        continue;
      }

      if (iteration >= this._min) {
        break;
      }

      return result;
    }

    return this._resolve(index, values).aggregate(result);
  };

  return Repetition;
})(_Atom3['default']);

exports['default'] = Repetition;
module.exports = exports['default'];