'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var Sequence = (function (_Atom) {
  function Sequence(atoms) {
    _classCallCheck(this, Sequence);

    _Atom.call(this);
    this._atoms = atoms;
  }

  _inherits(Sequence, _Atom);

  Sequence.prototype.run = function run(stream, index) {
    var values = ['sequence'];
    var result = undefined;

    for (var i = 0; i < this._atoms.length; i++) {
      result = this._atoms[i].run(stream, index).aggregate(result);

      if (!result.status) {
        return result;
      }

      values.push(result.value);
      index = result.index;
    }

    return this._resolve(index, values).aggregate(result);
  };

  return Sequence;
})(_Atom3['default']);

exports['default'] = Sequence;
module.exports = exports['default'];